# idm389
Idm389 is a flexible and simple identity management layer for 389 Directory Server

```
# dsidm
Available modules:
dsidm ipa
dsidm posixgroup
dsidm organisationalunit
dsidm user

# dsidm group
Available actions:
dsidm group create
dsidm group delete
dsidm group get
dsidm group get_dn
dsidm group list

# dsidm group list
Enter password for cn=Directory Manager on ldap://ldap.prd.example.com :

Accounting Managers
HR Managers
QA Managers
PD Managers

# dsidm group create
Enter password for cn=Directory Manager on ldap://ldap.prd.example.com :

Enter value for cn : NewGroup
Sucessfully created NewGroup

# dsidm group get NewGroup
Enter password for cn=Directory Manager on ldap://ldap.prd.example.com :

NewGroup

```


### Idm389

Idm389 is a command line tool that interacts with a new or existing Directory Server instances.

It allows the Administrator to easily add users, groups, organisational units, permissions and more. However it does not stop the Administrator customising their Directory Server instance, putting in custom subtrees, or anything else you might want.

If we put the avaliable administration tools on a scale:

*Most Controlled* --> *Most Flexible*

FreeIPA - idm389 - 389-ds

### FreeIPA

FreeIPA takes control of your environment. It's not open to changes the Administrator wants to make.

IPA is a bundle of:

* Directory Server, with IPA specific schema and plugins, with IPA only functionality. You may *not* add custom subtrees or data, you *must* use the IPA APIs.
* MitKrb5, with IPA specific backend storage
* Httpd, with IPA specific python rest API
* DNS, (optional), but you have to implement "certain" records for IPA to work - so you have a requirement on this anyway.
* Dogtag CA, (optional), with IPA specific behaviours
* SSSD, for client authentication. This has IPA specific behaviours also.

### Directory Server

At the opposite end, we have Directory Server. The Adminstrator has to design *every* aspect of the install. From the layout, to what schema to additioally add. How to get users and groups into the Directory, how to administer these effectively.

Directory Server on it's own is a "blank slate" and you must architect it. This requires a great deal of LDAP knowledge: Sometimes upwards of 5 years experience or more!


### Why something else?

Something in the middle is needed. Something that provides certain best practices to the Administrator, and easy to use tools. But without taking away the power of configuration of Directory Server, and without over complicating the environment.


